"""J.A.R.V.I.S. Member event handler."""
from dis_snek import Snake, listen
from dis_snek.models.discord.user import Member
from jarvis_core.db import q
from jarvis_core.db.models import Setting


class MemberEventHandler(object):
    """J.A.R.V.I.S. Member event handler."""

    def __init__(self, bot: Snake):
        self.bot = bot
        self.bot.add_listener(self.on_member_join)

    @listen()
    async def on_member_join(self, user: Member) -> None:
        """Handle on_member_join event."""
        guild = user.guild
        unverified = await Setting.find_one(q(guild=guild.id, setting="unverified"))
        if unverified:
            role = guild.get_role(unverified.value)
            if role not in user.roles:
                await user.add_roles(role, reason="User just joined and is unverified")
