"""J.A.R.V.I.S. unban background task handler."""
from datetime import datetime, timedelta

from dis_snek.ext.tasks.task import Task
from dis_snek.ext.tasks.triggers import IntervalTrigger
from jarvis_core.db import q
from jarvis_core.db.models import Ban, Unban

import jarvis


@Task.create(IntervalTrigger(minutes=10))
async def _unban() -> None:
    """J.A.R.V.I.S. unban background task."""
    jarvis_id = jarvis.jconfig.client_id
    bans = Ban.find(q(type="temp", active=True))
    async for ban in bans:
        if ban.created_at + timedelta(hours=ban.duration) < datetime.now() + timedelta(minutes=10):
            guild = await jarvis.jarvis.get_guild(ban.guild)
            user = await jarvis.jarvis.get_user(ban.user)
            if user:
                await guild.unban(user=user, reason="Ban expired")
            ban.update(q(active=False))
            await ban.commit()
            u = Unban(
                user=user.id,
                guild=guild.id,
                username=user.name,
                discrim=user.discriminator,
                admin=jarvis_id,
                reason="Ban expired",
            )
            await u.commit()
